#ifndef LowPassRootsH
#define LowPassRootsH

#include "Common.h"
#include "PFiftyOneRevD.h"

#define MAX_ELLIP_ITER 15
#define ELLIPARRAYSIZE 20  // needs to be > 10 and >= Max Num Poles + 1


void ReverseCoeff( double *P, int N );

int ButterworthPoly( int NumPoles, complex double *Roots );

int GaussianPoly( int NumPoles, complex double *Roots );

int AdjustablePoly( int NumPoles, complex double *Roots, double Gamma );

int ChebyshevPoly( int NumPoles, double Ripple, complex double *Roots );

int BesselPoly( int NumPoles, complex double *Roots );

int InvChebyPoly(
	int NumPoles,
	double StopBanddB,
	complex double *ChebyPoles,
	complex double *ChebyZeros,
	int *ZeroCount );

int PapoulisPoly( int NumPoles, complex double *Roots );

int EllipticPoly(
	int FiltOrder,
	double Ripple,
	double DesiredSBdB,
	complex double *EllipPoles,
	complex double *EllipZeros,
	int *ZeroCount );

#endif

