#ifndef QuadRootsRevHH
#define QuadRootsRevHH

#include "Common.h"

#define ZERO_PLUS   8.88178419700125232E-16      // 2^-50 = 4*DBL_EPSILON
#define ZERO_MINUS -8.88178419700125232E-16

// This is what we use to test for zero. Usually to avoid divide by zero.
#define TINY_VALUE  1.0E-30

void QuadRoots( long double *P, long double *RealPart, long double *ImagPart );

void CubicRoots( long double *P, long double *RealPart, long double *ImagPart );

void BiQuadRoots( long double *P, long double *RealPart, long double *ImagPart );

void ReversePoly( long double *P, int N );

void InvertRoots( int N, long double *RealRoot, long double *ImagRoot );

#endif

